﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Days360CSharpVS2008
{
    class CDays360
    {
        public static int Days360(DateTime pDateFrom, DateTime pDateTo)
        {
            return Days360(pDateFrom, pDateTo, true);
        }
        public static int Days360(DateTime pDateFrom, DateTime pDateTo, bool pNASD)
        {
            int mDayFrom, mDayTo;
            int iret;

            if (pDateTo < pDateFrom) return 0;

            mDayFrom = pDateFrom.Day;
            mDayTo = pDateTo.Day;

            CheckDays(pDateFrom, pDateTo, ref mDayFrom, ref mDayTo, pNASD);

            if (IsSameMonth(pDateFrom, pDateTo))
            {
                iret = mDayTo - mDayFrom;
                if (iret < 0) iret = 0;

                return iret;
            }
            iret = (30 - mDayFrom) + DaysFullMonth(pDateFrom, pDateTo) + mDayTo;

            if (iret < 0) iret = 0;

            return iret;
        }
        private static int DaysFullMonth(DateTime pDateFrom, DateTime pDateTo)
        {
            int iret = (pDateTo.Month - pDateFrom.Month - 1) * 30 + (pDateTo.Year - pDateFrom.Year) * 360;
            if (iret < 0) iret = 0;

            return iret;
        }
        private static bool IsSameMonth(DateTime pDateFrom, DateTime pDateTo)
        {
            return (pDateFrom.Month == pDateTo.Month && pDateFrom.Year == pDateTo.Year);
        }
        private static void CheckDays(DateTime pDateFrom, DateTime pDateTo, ref int pDayFrom, ref int pDayTo, bool pNASD)
        {
            if (pNASD)
            {
                if (LastDayOfMonth(pDateFrom) && pDateFrom.Month == 2)
                    pDayFrom = 30;

                if (pDayTo == 31 && pDayFrom >= 30)
                    pDayTo = 30;

                if (pDayFrom == 31)
                    pDayFrom = 30;
            }
            else
            {
                if (pDayFrom == 31)  pDayFrom = 30;
                if (pDayTo == 31)  pDayTo = 30;
            }
        }
        private static bool LastDayOfMonth(DateTime pDate)
        {
            return (pDate.AddDays(1).Month == pDate.Month + 1);
        }
    }
}
