﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Days360CSharpVS2008
{
    public partial class FrmDays360C : Form
    {
        CDays360Excel ObjDays360Excel;
        public FrmDays360C()
        {
            InitializeComponent();
            ObjDays360Excel = new CDays360Excel();
        }

        private void cmdExit_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void FrmDays360C_Load(object sender, EventArgs e)
        {
            CalcDiffFromPickers();
        }
        private void CalcDiffFromPickers()
        {
            LblDiffCSharp.Text = CDays360.Days360(DtpFrom.Value, DtpTo.Value).ToString();
            LblDiffExcel.Text = ObjDays360Excel.Days360(DtpFrom.Value, DtpTo.Value).ToString();
        }

        private void DtpFrom_ValueChanged(object sender, EventArgs e)
        {
            CalcDiffFromPickers();
        }

        private void DtpTo_ValueChanged(object sender, EventArgs e)
        {
            CalcDiffFromPickers();
        }

        private void CmdCalcAllDays_Click(object sender, EventArgs e)
        {
            if (DtpTo.Value <= DtpFrom.Value)
            {
                MessageBox.Show("The date to must be greater than the date from");
                return;
            }
            DateTime mDateFrom, mDateTo;

            DateTime LimitTo = DtpTo.Value;

            mDateFrom = DtpFrom.Value;
            LstDaysDiff.BeginUpdate();

            ListViewItem mlvitem;
            int iCSharp, iExcel, iCountErrors;
            iCountErrors = 0;

            LstDaysDiff.Items.Clear();

            while (mDateFrom <= DtpTo.Value)
            {
                mDateTo = mDateFrom.AddDays(1);
                while (mDateTo <= DtpTo.Value)
                {
                    mlvitem = new ListViewItem();

                    mlvitem.Text = mDateFrom.ToShortDateString();
                    mlvitem.SubItems.Add(mDateTo.ToShortDateString());

                    iCSharp = CDays360.Days360(mDateFrom, mDateTo);
                    mlvitem.SubItems.Add(iCSharp.ToString());

                    iExcel = ObjDays360Excel.Days360(mDateFrom, mDateTo);
                    mlvitem.SubItems.Add(iExcel.ToString());

                    mlvitem.SubItems.Add(iCSharp == iExcel ? "OK" : "Error");
                    if (iCSharp != iExcel) iCountErrors++;

                    LstDaysDiff.Items.Add(mlvitem);

                    mDateTo = mDateTo.AddDays(1);
                }
                mDateFrom = mDateFrom.AddDays(1);
            }
            LstDaysDiff.EndUpdate();
            MessageBox.Show("Ended \n" + LstDaysDiff.Items.Count.ToString() + " items\n" + iCountErrors.ToString() + " Errors");
        }
    }
}
